#!/bin/bash

rm AOP/Test/AOTTests
rm AOP/Test/CflowTests
rm AOP/Test/ELTTests
rm AOP/Test/NIAOTTests
rm AOP/Test/SecureAOTTests
rm AOP/Test/SecurePrivilegedAOTTests
rm AOP/Test/TestMacros

echo "===================================="
echo "Compiling AOT Tests"
echo "===================================="
ghc --make -O AOP/Test/AOTTests.hs

echo "===================================="
echo "Compiling NIAOT Tests"
echo "===================================="
ghc --make -O AOP/Test/NIAOTTests.hs

echo "===================================="
echo "Compiling ELT Tests"
echo "===================================="
ghc --make -O AOP/Test/ELTTests.hs

echo "===================================="
echo "Compiling Template Haskell macro tests"
echo "===================================="
ghc --make -O AOP/Test/TestMacros.hs

echo "===================================="
echo "Compiling Cflow tests"
echo "===================================="
ghc --make -O AOP/Test/CflowTests.hs

echo "===================================="
echo "Compiling Secure AOT tests"
echo "===================================="
ghc --make -O AOP/Test/SecureAOTTests.hs

echo "===================================="
echo "Compiling Secure Privileged AOT tests"
echo "===================================="
ghc --make -O AOP/Test/SecurePrivilegedAOTTests.hs

echo "***************************************************"
echo "****************** Running Tests ******************"

echo "===================================="
echo "Running AOT Tests"
./AOP/Test/AOTTests
echo "===================================="

echo "===================================="
echo "Running NIAOT Tests"
./AOP/Test/NIAOTTests
echo "===================================="

echo "===================================="
echo "Running ELT Tests"
./AOP/Test/ELTTests
echo "===================================="

echo "===================================="
echo "Running Template Haskell macro tests"
./AOP/Test/TestMacros
echo "===================================="

echo "===================================="
echo "Running Cflow tests"
./AOP/Test/CflowTests
echo "===================================="

echo "===================================="
echo "Running Secure AOT tests"
./AOP/Test/SecureAOTTests
echo "===================================="

echo "===================================="
echo "Running Secure Privileged AOT tests"
./AOP/Test/SecurePrivilegedAOTTests
echo "===================================="


